import traceback

# PyObjC's exception handling facilities are rather poor. If a Python exception occurs in a Python
# function called from Objective-C, it is transformed into an Objective-C exception, but the exact
# location of the exception is lost. @catch_exceptions is a decorator that prints a full traceback
# when an exception occurs. It should be liberally applied to methods of PyObjC classes.

def catch_exceptions(func):
	def exception_wrapper(*args, **kwargs):
		try:
			return func(*args, **kwargs)
		except:
			print "Exception in \"%s\"" % func.__name__
			traceback.print_exc()
			raise
	exception_wrapper.__name__ = "ewrap"+func.__name__
	return exception_wrapper
