from geometry import round_point

class pointmap(object):
	"""A pointmap is an object that maps integer coordinates of the form (x,y) to sets of objects.
"""
	def __init__(self):
		self.map = {}
	
	def add(self, point, obj):
		assert len(point)==2
		assert isinstance(point[0], int)
		assert isinstance(point[1], int)
		
		if point not in self.map:
			self.map[point] = set()
		assert obj not in self.map[point]
		self.map[point].add(obj)
	
	def remove(self, point, obj):
		assert len(point)==2
		assert isinstance(point[0], int)
		assert isinstance(point[1], int)
	
		self.map[point].remove(obj)
		if not self.map[point]:
			del self.map[point]
	
	def get(self, point):
		assert len(point)==2
		assert isinstance(point[0], int)
		assert isinstance(point[1], int)
		if point in self.map:
			for obj in self.map[point]:
				yield obj
		else:
			return
	
	def anything_at(self, point):
		assert len(point)==2
		assert isinstance(point[0], int)
		assert isinstance(point[1], int)
		return point in self.map
			