import objc
from Foundation import *
from AppKit import *

from geometry import *

class ManipulateDragSession(object):

	"""ManipulateDragSession is used when the user is dragging a slider or pushing a button or
	otherwise manipulating a control."""

	def __init__(self, view, component):
		self.view = view
		self.component = component
	
	def draw(self):
		pass
	
	def mouse_dragged(self, point):
		obj_point = untransform_point(self.component.transform, point)
		self.component.continue_manipulation(obj_point)
	
	def mouse_up(self, point):
		obj_point = untransform_point(self.component.transform, point)
		self.component.end_manipulation(obj_point)