import objc
from Foundation import *
from AppKit import *

from CE.Component import Component
from CE.Wire import Wire, WireEnd

from geometry import *

def photograph(bounds, objs, extradots=[]):
	bitmap = NSBitmapImageRep.alloc().initWithBitmapDataPlanes_pixelsWide_pixelsHigh_bitsPerSample_samplesPerPixel_hasAlpha_isPlanar_colorSpaceName_bitmapFormat_bytesPerRow_bitsPerPixel_(
			None, # Ask Cocoa to allocate memory
			bounds[1][0]*16.0, # Width
			bounds[1][1]*16.0, # Height
			8, # 8 bits per sample (True color)
			4, # 4 samples per pixel (RGBA)
			True, # Yes, we want an alpha channel
			False, # Must be nonplanar for NSGraphicsContext
			NSCalibratedRGBColorSpace,
			0, # No flags
			0, # Let Cocoa calculate bytes-per-row
			0) # Let Cocoa calculate bits-per-pixel
	
	gc = NSGraphicsContext.graphicsContextWithBitmapImageRep_(bitmap)
	old_gc = NSGraphicsContext.currentContext()
	NSGraphicsContext.setCurrentContext_(gc)
	
	transform = NSAffineTransform.transform()
	transform.scaleBy_(16.0)
	transform.translateXBy_yBy_(-bounds[0][0], -bounds[0][1])
	transform.concat()
	
	NSColor.clearColor().set()
	NSRectFill(bounds)
	
	for obj in objs:
		obj.draw()
	
	NSColor.blackColor().set()
	for loc in extradots:
		r = rect_around_point(loc, 0.2)
		NSBezierPath.bezierPathWithOvalInRect_(r).fill()
	
	NSGraphicsContext.setCurrentContext_(old_gc)
	
	return bitmap